"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var pipe_1 = require("./pipe");
var drop_1 = require("./drop");
var _counter_1 = require("./_counter");
var take_1 = require("./take");
var array = [1, 2, 3, 4, 5];
var expected = [3, 4, 5];
describe('data first', function () {
    test('should drop last', function () {
        expect((0, drop_1.drop)(array, 2)).toEqual(expected);
    });
});
describe('data last', function () {
    test('drop', function () {
        var result = (0, pipe_1.pipe)(array, (0, drop_1.drop)(2));
        expect(result).toEqual(expected);
    });
    test('drop with take', function () {
        var counter = (0, _counter_1.createCounter)();
        var result = (0, pipe_1.pipe)(array, counter.fn(), (0, drop_1.drop)(2), (0, take_1.take)(2));
        expect(counter.count).toHaveBeenCalledTimes(4);
        expect(result).toEqual([3, 4]);
    });
});
