import { LazyResult } from './_reduceLazy';
import { Pred, PredIndexedOptional, PredIndexed } from './_types';
export declare function filter<T, S extends T>(array: readonly T[], fn: (value: T) => value is S): S[];
export declare function filter<T>(array: readonly T[], fn: Pred<T, boolean>): T[];
export declare function filter<T, S extends T>(fn: (input: T) => input is S): (array: readonly T[]) => S[];
export declare function filter<T>(fn: Pred<T, boolean>): (array: readonly T[]) => T[];
export declare namespace filter {
    function indexed<T, S extends T>(array: readonly T[], fn: (input: T, index: number, array: T[]) => input is S): S[];
    function indexed<T>(array: readonly T[], fn: PredIndexed<T, boolean>): T[];
    function indexed<T, S extends T>(fn: (input: T, index: number, array: T[]) => input is S): (array: readonly T[]) => S[];
    function indexed<T>(fn: PredIndexed<T, boolean>): (array: readonly T[]) => T[];
    const lazy: <T>(fn: PredIndexedOptional<T, boolean>) => (value: T, index?: number | undefined, array?: T[] | undefined) => LazyResult<T>;
    const lazyIndexed: (<T>(fn: PredIndexedOptional<T, boolean>) => (value: T, index?: number | undefined, array?: T[] | undefined) => LazyResult<T>) & {
        indexed: true;
    };
}
//# sourceMappingURL=filter.d.ts.map