import { Pred, PredIndexedOptional, PredIndexed } from './_types';
export declare function find<T>(array: readonly T[], fn: Pred<T, boolean>): T | undefined;
export declare function find<T = never>(fn: Pred<T, boolean>): (array: readonly T[]) => T | undefined;
export declare namespace find {
    function indexed<T>(array: readonly T[], fn: PredIndexed<T, boolean>): T | undefined;
    function indexed<T>(fn: PredIndexed<T, boolean>): (array: readonly T[]) => T | undefined;
    const lazy: (<T>(fn: PredIndexedOptional<T, boolean>) => (value: T, index?: number | undefined, array?: T[] | undefined) => {
        done: boolean;
        hasNext: boolean;
        next: T;
    }) & {
        single: true;
    };
    const lazyIndexed: (<T>(fn: PredIndexedOptional<T, boolean>) => (value: T, index?: number | undefined, array?: T[] | undefined) => {
        done: boolean;
        hasNext: boolean;
        next: T;
    }) & {
        indexed: true;
    } & {
        single: true;
    };
}
//# sourceMappingURL=find.d.ts.map