"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var flatMap_1 = require("./flatMap");
var pipe_1 = require("./pipe");
var find_1 = require("./find");
var _counter_1 = require("./_counter");
describe('data_first', function () {
    it('flatMap', function () {
        var result = (0, flatMap_1.flatMap)([1, 2], function (x) { return [x * 2, x * 3]; });
        expect(result).toEqual([2, 3, 4, 6]);
    });
});
describe('data_last', function () {
    it('flatMap', function () {
        var result = (0, flatMap_1.flatMap)(function (x) { return [x * 2, x * 3]; })([1, 2]);
        expect(result).toEqual([2, 3, 4, 6]);
    });
    describe('pipe', function () {
        test('with find', function () {
            var counter1 = (0, _counter_1.createCounter)();
            var counter2 = (0, _counter_1.createCounter)();
            var result = (0, pipe_1.pipe)([10, 20, 30, 40], counter1.fn(), (0, flatMap_1.flatMap)(function (x) { return [x, x + 1, x + 2, x + 3]; }), counter2.fn(), (0, find_1.find)(function (x) { return x === 22; }));
            expect(counter1.count).toHaveBeenCalledTimes(2);
            expect(counter2.count).toHaveBeenCalledTimes(7);
            expect(result).toEqual(22);
        });
    });
});
