"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var flatMapToObj_1 = require("./flatMapToObj");
var pipe_1 = require("./pipe");
describe('data_first', function () {
    it('flatMapToObj', function () {
        var result = (0, flatMapToObj_1.flatMapToObj)([1, 2, 3], function (x) {
            return x % 2 === 1 ? [[String(x), x]] : [];
        });
        expect(result).toEqual({ 1: 1, 3: 3 });
    });
    it('flatMapToObj.indexed', function () {
        var result = flatMapToObj_1.flatMapToObj.indexed(['a', 'b'], function (x, i) { return [
            [x, i],
            [x + x, i + i],
        ]; });
        expect(result).toEqual({ a: 0, aa: 0, b: 1, bb: 2 });
    });
});
describe('data_last', function () {
    it('flatMapToObj', function () {
        var result = (0, pipe_1.pipe)([1, 2, 3], (0, flatMapToObj_1.flatMapToObj)(function (x) { return (x % 2 === 1 ? [[String(x), x]] : []); }));
        expect(result).toEqual({ 1: 1, 3: 3 });
    });
    it('flatMapToObj.indexed', function () {
        var result = (0, pipe_1.pipe)(['a', 'b'], flatMapToObj_1.flatMapToObj.indexed(function (x, i) { return [
            [x, i],
            [x + x, i + i],
        ]; }));
        expect(result).toEqual({ a: 0, aa: 0, b: 1, bb: 2 });
    });
});
