"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.flattenDeep = void 0;
var _reduceLazy_1 = require("./_reduceLazy");
var purry_1 = require("./purry");
function flattenDeep() {
    return (0, purry_1.purry)(_flattenDeep, arguments, flattenDeep.lazy);
}
exports.flattenDeep = flattenDeep;
function _flattenDeep(items) {
    return (0, _reduceLazy_1._reduceLazy)(items, flattenDeep.lazy());
}
function _flattenDeepValue(value) {
    if (!Array.isArray(value)) {
        return value;
    }
    var ret = [];
    value.forEach(function (item) {
        if (Array.isArray(item)) {
            ret.push.apply(ret, flattenDeep(item));
        }
        else {
            ret.push(item);
        }
    });
    return ret;
}
(function (flattenDeep) {
    function lazy() {
        return function (value) {
            var next = _flattenDeepValue(value);
            if (Array.isArray(next)) {
                return {
                    done: false,
                    hasNext: true,
                    hasMany: true,
                    next: next,
                };
            }
            return {
                done: false,
                hasNext: true,
                next: next,
            };
        };
    }
    flattenDeep.lazy = lazy;
})(flattenDeep = exports.flattenDeep || (exports.flattenDeep = {}));
