"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var flattenDeep_1 = require("./flattenDeep");
var pipe_1 = require("./pipe");
var find_1 = require("./find");
var _counter_1 = require("./_counter");
test('flatten', function () {
    expect((0, flattenDeep_1.flattenDeep)([[1, 2], 3, [4, 5]])).toEqual([1, 2, 3, 4, 5]);
});
test('nested', function () {
    expect((0, flattenDeep_1.flattenDeep)([
        [1, 2],
        [[3], [4, 5]],
    ])).toEqual([1, 2, 3, 4, 5]);
});
describe('pipe', function () {
    test('with find', function () {
        var counter1 = (0, _counter_1.createCounter)();
        var counter2 = (0, _counter_1.createCounter)();
        var result = (0, pipe_1.pipe)([[1, 2], [[3]], [[4, 5]]], counter1.fn(), (0, flattenDeep_1.flattenDeep)(), counter2.fn(), (0, find_1.find)(function (x) { return x - 1 === 2; }));
        expect(counter1.count).toHaveBeenCalledTimes(2);
        expect(counter2.count).toHaveBeenCalledTimes(3);
        expect(result).toEqual(3);
    });
});
