"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var forEachObj_1 = require("./forEachObj");
var pipe_1 = require("./pipe");
var obj = {
    a: 1,
    b: 2,
    c: 3,
};
describe('data_first', function () {
    it('forEachObj', function () {
        var cb = jest.fn();
        var result = (0, forEachObj_1.forEachObj)(obj, cb);
        expect(cb.mock.calls).toEqual([[1], [2], [3]]);
        expect(result).toEqual(obj);
    });
    it('forEachObj.indexed', function () {
        var cb = jest.fn();
        var result = forEachObj_1.forEachObj.indexed(obj, cb);
        expect(cb.mock.calls).toEqual([
            [1, 'a', obj],
            [2, 'b', obj],
            [3, 'c', obj],
        ]);
        expect(result).toEqual(obj);
    });
});
describe('data_last', function () {
    it('forEachObj', function () {
        var cb = jest.fn();
        var result = (0, pipe_1.pipe)(obj, (0, forEachObj_1.forEachObj)(cb));
        expect(cb.mock.calls).toEqual([[1], [2], [3]]);
        expect(result).toEqual(obj);
    });
    it('forEachObj.indexed', function () {
        var cb = jest.fn();
        var result = (0, pipe_1.pipe)(obj, forEachObj_1.forEachObj.indexed(cb));
        expect(cb.mock.calls).toEqual([
            [1, 'a', obj],
            [2, 'b', obj],
            [3, 'c', obj],
        ]);
        expect(result).toEqual(obj);
    });
});
