"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var groupBy_1 = require("./groupBy");
var pipe_1 = require("./pipe");
var array = [
    { a: 1, b: 1 },
    { a: 1, b: 2 },
    { a: 2, b: 1 },
    { a: 1, b: 3 },
];
var expected = {
    1: [
        { a: 1, b: 1 },
        { a: 1, b: 2 },
        { a: 1, b: 3 },
    ],
    2: [{ a: 2, b: 1 }],
};
describe('data first', function () {
    test('groupBy', function () {
        expect((0, groupBy_1.groupBy)(array, function (x) { return x.a; })).toEqual(expected);
    });
    test('groupBy.indexed', function () {
        expect(groupBy_1.groupBy.indexed(array, function (x) { return x.a; })).toEqual(expected);
    });
});
describe('data last', function () {
    test('groupBy', function () {
        expect((0, pipe_1.pipe)(array, (0, groupBy_1.groupBy)(function (x) { return x.a; }))).toEqual(expected);
    });
    test('groupBy.indexed', function () {
        expect((0, pipe_1.pipe)(array, groupBy_1.groupBy.indexed(function (x) { return x.a; }))).toEqual(expected);
    });
});
