"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isNot = exports.isTruthy = exports.isDate = exports.isError = exports.isNil = exports.isFunction = exports.isObject = exports.isArray = exports.isPromise = exports.isBoolean = exports.isDefined = exports.isNumber = exports.isString = void 0;
function isString(data) {
    return typeof data === 'string';
}
exports.isString = isString;
function isNumber(data) {
    return typeof data === 'number' && !isNaN(data);
}
exports.isNumber = isNumber;
function isDefined(data) {
    return typeof data !== 'undefined' && data !== null;
}
exports.isDefined = isDefined;
function isBoolean(data) {
    return typeof data === 'boolean';
}
exports.isBoolean = isBoolean;
function isPromise(data) {
    return data instanceof Promise;
}
exports.isPromise = isPromise;
function isArray(data) {
    return Array.isArray(data);
}
exports.isArray = isArray;
function isObject(data) {
    return !!data && !Array.isArray(data) && typeof data === 'object';
}
exports.isObject = isObject;
function isFunction(data) {
    return typeof data === 'function';
}
exports.isFunction = isFunction;
function isNil(data) {
    return data == null;
}
exports.isNil = isNil;
function isError(data) {
    return data instanceof Error;
}
exports.isError = isError;
function isDate(data) {
    return data instanceof Date;
}
exports.isDate = isDate;
function isTruthy(data) {
    return !!data;
}
exports.isTruthy = isTruthy;
function isNot(predicate) {
    return function (data) {
        return !predicate(data);
    };
}
exports.isNot = isNot;
