"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var keys_1 = require("./keys");
var pipe_1 = require("./pipe");
describe('Test for keys', function () {
    it('should return keys of array', function () {
        expect((0, keys_1.keys)(['x', 'y', 'z'])).toEqual(['0', '1', '2']);
    });
    it('should return keys of object', function () {
        expect((0, keys_1.keys)({ a: 'x', b: 'y', c: 'z' })).toEqual(['a', 'b', 'c']);
    });
    describe('strict', function () {
        it('should return strict types', function () {
            var actual = keys_1.keys.strict({ 5: 'x', b: 'y', c: 'z' });
            expect(actual).toEqual(['5', 'b', 'c']);
            var result = true;
            expect(result).toEqual(true);
        });
        it('should work with Partial in pipe', function () {
            var data = {
                foo: '1',
                bar: 7,
            };
            var actual = (0, pipe_1.pipe)(data, keys_1.keys.strict);
            expect(actual).toEqual(['foo', 'bar']);
            var result = true;
            expect(result).toEqual(true);
        });
    });
});
