import { LazyResult } from './_reduceLazy';
import { Pred, PredIndexedOptional, PredIndexed } from './_types';
export declare function map<T, K>(array: readonly T[], fn: Pred<T, K>): K[];
export declare function map<T, K>(fn: Pred<T, K>): (array: readonly T[]) => K[];
export declare namespace map {
    function indexed<T, K>(array: readonly T[], fn: PredIndexed<T, K>): K[];
    function indexed<T, K>(fn: PredIndexed<T, K>): (array: readonly T[]) => K[];
    const lazy: <T, K>(fn: PredIndexedOptional<T, K>) => (value: T, index?: number | undefined, array?: T[] | undefined) => LazyResult<K>;
    const lazyIndexed: (<T, K>(fn: PredIndexedOptional<T, K>) => (value: T, index?: number | undefined, array?: T[] | undefined) => LazyResult<K>) & {
        indexed: true;
    };
}
//# sourceMappingURL=map.d.ts.map