"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var meanBy_1 = require("./meanBy");
var pipe_1 = require("./pipe");
var array = [{ a: 1 }, { a: 2 }, { a: 4 }, { a: 5 }, { a: 3 }];
describe('data first', function () {
    test('meanBy', function () {
        expect((0, meanBy_1.meanBy)(array, function (x) { return x.a; })).toEqual(3);
    });
    test('meanBy.indexed', function () {
        expect(meanBy_1.meanBy.indexed(array, function (x, idx) { return x.a + idx; })).toEqual(5);
    });
    test('should handle empty array', function () {
        expect((0, meanBy_1.meanBy)([], function (x) { return x; })).toBeNaN();
    });
});
describe('data last', function () {
    test('meanBy', function () {
        expect((0, pipe_1.pipe)(array, (0, meanBy_1.meanBy)(function (x) { return x.a; }))).toEqual(3);
    });
    test('meanBy.indexed', function () {
        expect((0, pipe_1.pipe)(array, meanBy_1.meanBy.indexed(function (x, idx) { return x.a + idx; }))).toEqual(5);
    });
    test('should handle empty array', function () {
        expect((0, pipe_1.pipe)([], (0, meanBy_1.meanBy)(function (x) { return x; }))).toBeNaN();
    });
});
