"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var minBy_1 = require("./minBy");
var pipe_1 = require("./pipe");
var array = [{ a: 2 }, { a: 5 }, { a: 1 }, { a: 3 }];
var expected = { a: 1 };
describe('data first', function () {
    test('minBy', function () {
        expect((0, minBy_1.minBy)(array, function (x) { return x.a; })).toEqual(expected);
    });
    test('minBy.indexed', function () {
        expect(minBy_1.minBy.indexed(array, function (x, idx) { return x.a + idx; })).toEqual({ a: 2 });
    });
});
describe('data last', function () {
    test('minBy', function () {
        var actual = (0, pipe_1.pipe)(array, (0, minBy_1.minBy)(function (x) { return x.a; }));
        expect(actual).toEqual(expected);
    });
    test('minBy.indexed', function () {
        var actual = (0, pipe_1.pipe)(array, minBy_1.minBy.indexed(function (x, idx) { return x.a + idx; }));
        expect(actual).toEqual({ a: 2 });
    });
});
