"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var omitBy_1 = require("./omitBy");
var pipe_1 = require("./pipe");
describe('data first', function () {
    test('it should omit props', function () {
        var result = (0, omitBy_1.omitBy)({ a: 1, b: 2, A: 3, B: 4 }, function (val, key) { return key.toUpperCase() === key; });
        var resultType = true;
        expect(result).toStrictEqual({ a: 1, b: 2 });
        expect(resultType).toStrictEqual(true);
    });
    test('allow partial type', function () {
        var result = (0, omitBy_1.omitBy)({}, function (val, key) { return key === 'a'; });
        var resultType = true;
        expect(result).toEqual({});
        expect(resultType).toStrictEqual(true);
    });
});
describe('data last', function () {
    test('it should omit props', function () {
        var result = (0, pipe_1.pipe)({ a: 1, b: 2, A: 3, B: 4 }, (0, omitBy_1.omitBy)(function (val, key) { return key.toUpperCase() === key; }));
        var resultType = true;
        expect(result).toStrictEqual({ a: 1, b: 2 });
        expect(resultType).toStrictEqual(true);
    });
    test('allow partial type', function () {
        var result = (0, pipe_1.pipe)({}, (0, omitBy_1.omitBy)(function (val, key) { return key.toUpperCase() === key; }));
        var resultType = true;
        expect(result).toEqual({});
        expect(resultType).toStrictEqual(true);
    });
});
