"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var partition_1 = require("./partition");
var pipe_1 = require("./pipe");
var array = [
    { a: 1, b: 1 },
    { a: 1, b: 2 },
    { a: 2, b: 1 },
    { a: 1, b: 3 },
];
var expected = [
    [
        { a: 1, b: 1 },
        { a: 1, b: 2 },
        { a: 1, b: 3 },
    ],
    [{ a: 2, b: 1 }],
];
describe('data first', function () {
    test('partition', function () {
        expect((0, partition_1.partition)(array, function (x) { return x.a === 1; })).toEqual(expected);
    });
    test('partition with type guard', function () {
        var isNumber = function (value) {
            return typeof value === 'number';
        };
        var actual = (0, partition_1.partition)([1, 'a', 2, 'b'], isNumber);
        expect(actual).toEqual([
            [1, 2],
            ['a', 'b'],
        ]);
        var result = true;
        expect(result).toBe(true);
    });
    test('partition.indexed', function () {
        expect(partition_1.partition.indexed(array, function (_, index) { return index !== 2; })).toEqual(expected);
    });
});
describe('data last', function () {
    test('partition', function () {
        expect((0, pipe_1.pipe)(array, (0, partition_1.partition)(function (x) { return x.a === 1; }))).toEqual(expected);
    });
    test('partition.indexed', function () {
        expect((0, pipe_1.pipe)(array, partition_1.partition.indexed(function (_, index) { return index !== 2; }))).toEqual(expected);
    });
});
