import { NonNull, Key } from './_types';
declare type Pathable<T> = {
    [K in AllKeys<T>]: TypesForKey<T, K>;
};
declare type AllKeys<T> = T extends infer I ? keyof I : never;
declare type TypesForKey<T, K extends Key> = T extends infer I ? K extends keyof I ? I[K] : never : never;
declare type PathValue1<T, A extends keyof Pathable<T>> = NonNull<Pathable<T>>[A];
declare type Pathable1<T, A extends keyof Pathable<T>> = Pathable<PathValue1<T, A>>;
declare type PathValue2<T, A extends keyof Pathable<T>, B extends keyof Pathable1<T, A>> = NonNull<Pathable1<T, A>>[B];
declare type Pathable2<T, A extends keyof Pathable<T>, B extends keyof Pathable1<T, A>> = Pathable<PathValue2<T, A, B>>;
declare type PathValue3<T, A extends keyof Pathable<T>, B extends keyof Pathable1<T, A>, C extends keyof Pathable2<T, A, B>> = NonNull<Pathable2<T, A, B>>[C];
export declare function pathOr<T, A extends keyof Pathable<T>>(object: T, path: readonly [A], defaultValue: PathValue1<T, A>): PathValue1<T, A>;
export declare function pathOr<T, A extends keyof Pathable<T>, B extends keyof Pathable1<T, A>>(object: T, path: readonly [A, B], defaultValue: PathValue2<T, A, B>): PathValue2<T, A, B>;
export declare function pathOr<T, A extends keyof Pathable<T>, B extends keyof Pathable1<T, A>, C extends keyof Pathable2<T, A, B>>(object: T, path: readonly [A, B, C], defaultValue: PathValue3<T, A, B, C>): PathValue3<T, A, B, C>;
export declare function pathOr<T, A extends keyof Pathable<T>>(path: readonly [A], defaultValue: PathValue1<T, A>): (object: T) => PathValue1<T, A>;
export declare function pathOr<T, A extends keyof Pathable<T>, B extends keyof Pathable1<T, A>>(path: readonly [A, B], defaultValue: PathValue2<T, A, B>): (object: T) => PathValue2<T, A, B>;
export declare function pathOr<T, A extends keyof Pathable<T>, B extends keyof Pathable1<T, A>, C extends keyof Pathable2<T, A, B>>(path: readonly [A, B, C], defaultValue: PathValue3<T, A, B, C>): (object: T) => PathValue3<T, A, B, C>;
export {};
//# sourceMappingURL=pathOr.d.ts.map