"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var pathOr_1 = require("./pathOr");
var pipe_1 = require("./pipe");
var obj = {
    a: {
        b: {
            c: 1,
        },
    },
    y: 10,
};
describe('data first', function () {
    test('should return default value (input undefined)', function () {
        expect((0, pathOr_1.pathOr)(undefined, ['x'], 2)).toEqual(2);
    });
    test('should return value', function () {
        expect((0, pathOr_1.pathOr)(obj, ['y'], 2)).toEqual(10);
    });
    test('should return default value', function () {
        expect((0, pathOr_1.pathOr)(obj, ['x'], 2)).toEqual(2);
    });
    test('should return value (2 level deep)', function () {
        expect((0, pathOr_1.pathOr)(obj, ['a', 'b'], { c: 0 })).toEqual({ c: 1 });
    });
    test('should return default value (2 level deep)', function () {
        expect((0, pathOr_1.pathOr)(obj, ['a', 'z'], 3)).toEqual(3);
    });
    test('should return value (3 level deep)', function () {
        expect((0, pathOr_1.pathOr)(obj, ['a', 'b', 'c'], 0)).toEqual(1);
    });
});
describe('data last', function () {
    test('1 level', function () {
        expect((0, pipe_1.pipe)(obj, (0, pathOr_1.pathOr)(['x'], 1))).toEqual(1);
    });
    test('2 level', function () {
        expect((0, pipe_1.pipe)(obj, (0, pathOr_1.pathOr)(['a', 'z'], 1))).toEqual(1);
    });
    test('3 level', function () {
        expect((0, pipe_1.pipe)(obj, (0, pathOr_1.pathOr)(['a', 'b', 'd'], 1))).toEqual(1);
    });
});
