"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var pipe_1 = require("./pipe");
var reject_1 = require("./reject");
var _counter_1 = require("./_counter");
describe('data_first', function () {
    it('reject', function () {
        var result = (0, reject_1.reject)([1, 2, 3], function (x) { return x % 2 === 0; });
        expect(result).toEqual([1, 3]);
    });
    it('reject.indexed', function () {
        var result = reject_1.reject.indexed([1, 2, 3], function (x, i) { return x % 2 === 0 && i === 1; });
        expect(result).toEqual([1, 3]);
    });
});
describe('data_last', function () {
    it('filter', function () {
        var counter = (0, _counter_1.createCounter)();
        var result = (0, pipe_1.pipe)([1, 2, 3], (0, reject_1.reject)(function (x) { return x % 2 === 0; }), counter.fn());
        expect(counter.count).toHaveBeenCalledTimes(2);
        expect(result).toEqual([1, 3]);
    });
    it('filter.indexed', function () {
        var counter = (0, _counter_1.createCounter)();
        var result = (0, pipe_1.pipe)([1, 2, 3], reject_1.reject.indexed(function (x, i) { return x % 2 === 0 && i === 1; }), counter.fn());
        expect(counter.count).toHaveBeenCalledTimes(2);
        expect(result).toEqual([1, 3]);
    });
});
