declare type Direction = 'asc' | 'desc';
declare type SortProjection<T> = (x: T) => Comparable;
declare type ComparablePrimitive = number | string | boolean;
declare type Comparable = ComparablePrimitive | {
    valueOf(): ComparablePrimitive;
};
declare type SortPair<T> = readonly [SortProjection<T>, Direction];
declare type SortRule<T> = SortProjection<T> | SortPair<T>;
export declare function sortBy<T>(sort: SortRule<T>, ...sorts: SortRule<T>[]): (array: readonly T[]) => T[];
export declare function sortBy<T>(array: readonly T[], ...sorts: SortRule<T>[]): T[];
export {};
//# sourceMappingURL=sortBy.d.ts.map