"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var sumBy_1 = require("./sumBy");
var pipe_1 = require("./pipe");
var array = [{ a: 1 }, { a: 2 }, { a: 4 }, { a: 5 }, { a: 3 }];
var expected = 15;
describe('data first', function () {
    test('sumBy', function () {
        expect((0, sumBy_1.sumBy)(array, function (x) { return x.a; })).toEqual(expected);
    });
    test('sumBy.indexed', function () {
        expect(sumBy_1.sumBy.indexed(array, function (x, idx) { return x.a + idx; })).toEqual(25);
    });
});
describe('data last', function () {
    test('sumBy', function () {
        expect((0, pipe_1.pipe)(array, (0, sumBy_1.sumBy)(function (x) { return x.a; }))).toEqual(expected);
    });
    test('sumBy.indexed', function () {
        var actual = (0, pipe_1.pipe)(array, sumBy_1.sumBy.indexed(function (x, idx) { return x.a + idx; }));
        expect(actual).toEqual(25);
    });
});
