import { purry } from './purry';
import { _reduceLazy } from './_reduceLazy';
export function differenceWith() {
    return purry(_differenceWith, arguments, differenceWith.lazy);
}
function _differenceWith(array, other, isEquals) {
    var lazy = differenceWith.lazy(other, isEquals);
    return _reduceLazy(array, lazy);
}
(function (differenceWith) {
    function lazy(other, isEquals) {
        return function (value) {
            if (other.every(function (otherValue) { return !isEquals(value, otherValue); })) {
                return {
                    done: false,
                    hasNext: true,
                    next: value,
                };
            }
            return {
                done: false,
                hasNext: false,
            };
        };
    }
    differenceWith.lazy = lazy;
})(differenceWith || (differenceWith = {}));
