import { findLast } from './findLast';
import { pipe } from './pipe';
var array = [1, 2, 3, 4];
describe('data first', function () {
    test('findLast', function () {
        expect(findLast(array, function (x) { return x % 2 === 1; })).toEqual(3);
    });
    test('findLast.indexed', function () {
        expect(findLast.indexed(array, function (x, i) { return x === 3 && i === 2; })).toEqual(3);
    });
    test('findLast first value', function () {
        expect(findLast(array, function (x) { return x === 1; })).toEqual(1);
    });
    test('findLast no match', function () {
        expect(findLast(array, function (x) { return x === 5; })).toBeUndefined();
    });
});
describe('data last', function () {
    test('findLast', function () {
        var actual = pipe([1, 2, 3, 4], findLast(function (x) { return x % 2 === 1; }));
        expect(actual).toEqual(3);
    });
    test('findLast.indexed', function () {
        var actual = pipe([1, 2, 3, 4], findLast.indexed(function (x, i) { return x === 3 && i === 2; }));
        expect(actual).toEqual(3);
    });
});
