import { keys } from './keys';
import { pipe } from './pipe';
describe('Test for keys', function () {
    it('should return keys of array', function () {
        expect(keys(['x', 'y', 'z'])).toEqual(['0', '1', '2']);
    });
    it('should return keys of object', function () {
        expect(keys({ a: 'x', b: 'y', c: 'z' })).toEqual(['a', 'b', 'c']);
    });
    describe('strict', function () {
        it('should return strict types', function () {
            var actual = keys.strict({ 5: 'x', b: 'y', c: 'z' });
            expect(actual).toEqual(['5', 'b', 'c']);
            var result = true;
            expect(result).toEqual(true);
        });
        it('should work with Partial in pipe', function () {
            var data = {
                foo: '1',
                bar: 7,
            };
            var actual = pipe(data, keys.strict);
            expect(actual).toEqual(['foo', 'bar']);
            var result = true;
            expect(result).toEqual(true);
        });
    });
});
