import { meanBy } from './meanBy';
import { pipe } from './pipe';
var array = [{ a: 1 }, { a: 2 }, { a: 4 }, { a: 5 }, { a: 3 }];
describe('data first', function () {
    test('meanBy', function () {
        expect(meanBy(array, function (x) { return x.a; })).toEqual(3);
    });
    test('meanBy.indexed', function () {
        expect(meanBy.indexed(array, function (x, idx) { return x.a + idx; })).toEqual(5);
    });
    test('should handle empty array', function () {
        expect(meanBy([], function (x) { return x; })).toBeNaN();
    });
});
describe('data last', function () {
    test('meanBy', function () {
        expect(pipe(array, meanBy(function (x) { return x.a; }))).toEqual(3);
    });
    test('meanBy.indexed', function () {
        expect(pipe(array, meanBy.indexed(function (x, idx) { return x.a + idx; }))).toEqual(5);
    });
    test('should handle empty array', function () {
        expect(pipe([], meanBy(function (x) { return x; }))).toBeNaN();
    });
});
