import { omitBy } from './omitBy';
import { pipe } from './pipe';
describe('data first', function () {
    test('it should omit props', function () {
        var result = omitBy({ a: 1, b: 2, A: 3, B: 4 }, function (val, key) { return key.toUpperCase() === key; });
        var resultType = true;
        expect(result).toStrictEqual({ a: 1, b: 2 });
        expect(resultType).toStrictEqual(true);
    });
    test('allow partial type', function () {
        var result = omitBy({}, function (val, key) { return key === 'a'; });
        var resultType = true;
        expect(result).toEqual({});
        expect(resultType).toStrictEqual(true);
    });
});
describe('data last', function () {
    test('it should omit props', function () {
        var result = pipe({ a: 1, b: 2, A: 3, B: 4 }, omitBy(function (val, key) { return key.toUpperCase() === key; }));
        var resultType = true;
        expect(result).toStrictEqual({ a: 1, b: 2 });
        expect(resultType).toStrictEqual(true);
    });
    test('allow partial type', function () {
        var result = pipe({}, omitBy(function (val, key) { return key.toUpperCase() === key; }));
        var resultType = true;
        expect(result).toEqual({});
        expect(resultType).toStrictEqual(true);
    });
});
