import { partition } from './partition';
import { pipe } from './pipe';
var array = [
    { a: 1, b: 1 },
    { a: 1, b: 2 },
    { a: 2, b: 1 },
    { a: 1, b: 3 },
];
var expected = [
    [
        { a: 1, b: 1 },
        { a: 1, b: 2 },
        { a: 1, b: 3 },
    ],
    [{ a: 2, b: 1 }],
];
describe('data first', function () {
    test('partition', function () {
        expect(partition(array, function (x) { return x.a === 1; })).toEqual(expected);
    });
    test('partition with type guard', function () {
        var isNumber = function (value) {
            return typeof value === 'number';
        };
        var actual = partition([1, 'a', 2, 'b'], isNumber);
        expect(actual).toEqual([
            [1, 2],
            ['a', 'b'],
        ]);
        var result = true;
        expect(result).toBe(true);
    });
    test('partition.indexed', function () {
        expect(partition.indexed(array, function (_, index) { return index !== 2; })).toEqual(expected);
    });
});
describe('data last', function () {
    test('partition', function () {
        expect(pipe(array, partition(function (x) { return x.a === 1; }))).toEqual(expected);
    });
    test('partition.indexed', function () {
        expect(pipe(array, partition.indexed(function (_, index) { return index !== 2; }))).toEqual(expected);
    });
});
