import { pickBy } from './pickBy';
import { pipe } from './pipe';
describe('data first', function () {
    test('it should pick props', function () {
        var result = pickBy({ a: 1, b: 2, A: 3, B: 4 }, function (val, key) { return key.toUpperCase() === key; });
        var resultType = true;
        expect(result).toStrictEqual({ A: 3, B: 4 });
        expect(resultType).toStrictEqual(true);
    });
    test('allow undefined or null', function () {
        expect(pickBy(undefined, function (val, key) { return key === 'foo'; })).toEqual({});
        expect(pickBy(null, function (val, key) { return key === 'foo'; })).toEqual({});
    });
    test('allow partial type', function () {
        var result = pickBy({}, function (val, key) { return key === 'a'; });
        var resultType = true;
        expect(result).toEqual({});
        expect(resultType).toStrictEqual(true);
    });
});
describe('data last', function () {
    test('it should pick props', function () {
        var result = pipe({ a: 1, b: 2, A: 3, B: 4 }, pickBy(function (val, key) { return key.toUpperCase() === key; }));
        var resultType = true;
        expect(result).toStrictEqual({ A: 3, B: 4 });
        expect(resultType).toStrictEqual(true);
    });
    test('allow partial type', function () {
        var result = pipe({}, pickBy(function (val, key) { return key.toUpperCase() === key; }));
        var resultType = true;
        expect(result).toEqual({});
        expect(resultType).toStrictEqual(true);
    });
});
