import { sumBy } from './sumBy';
import { pipe } from './pipe';
var array = [{ a: 1 }, { a: 2 }, { a: 4 }, { a: 5 }, { a: 3 }];
var expected = 15;
describe('data first', function () {
    test('sumBy', function () {
        expect(sumBy(array, function (x) { return x.a; })).toEqual(expected);
    });
    test('sumBy.indexed', function () {
        expect(sumBy.indexed(array, function (x, idx) { return x.a + idx; })).toEqual(25);
    });
});
describe('data last', function () {
    test('sumBy', function () {
        expect(pipe(array, sumBy(function (x) { return x.a; }))).toEqual(expected);
    });
    test('sumBy.indexed', function () {
        var actual = pipe(array, sumBy.indexed(function (x, idx) { return x.a + idx; }));
        expect(actual).toEqual(25);
    });
});
